AI_DIR = "./AI/USER_AI/"
require (AI_DIR.."ai_comm.lua")

SAVEFILENAME = AI_DIR.."savedata.ini"
MYIDFILENAME = AI_DIR.."homid.ini"
FRIENDIDFILENAME = AI_DIR.."mercid.ini"

AutoShutdownTime		= 0 	--    
AutoShutdownTimeout		= 0 	--  

UseLambLikeABullet		= 0	--     Castling

HealSkill				= 0
HealSkillTiming				= -1	--  
HealSkillOwnerHPPerc 			= 0
HealSkillHomunHPPerc 			= 0
HealSkillStopSP 			= 0
HealSkillLevelOwner 			= 0
HealSkillLevelHomun 			= 0
HealSkillMaxAttempts 			= 0	--  -  
HealSkillTimeout 			= 0 	-- ,     

HealSkillLevelAttempted			= 0
HealSkillTimeAttempted			= 0
HealSkillOwnerHPAttempted			= 0
HealSkillHomunHPAttempted			= 0
HealSkillFails 				= 0
HealSkillDelay 				= 0

NewMobID_Flag			= 0	--     ID 


function ReadConfig_Hom()
	if set_table.HomSearchPriority ~= nil then
		AttackPriority = txt2table (set_table.HomSearchPriority)
	else
		AttackPriority={2,1,5,6,4}
	end

	followMasterTarget  = set_table.HomFollowMasterTarget or 0

	set_table.AutoShutdownTimeout = set_table.AutoShutdownTimeout or 120
	AutoShutdownTimeout = set_table.AutoShutdownTimeout * 60000

	AttackMotionCancel1 = set_table.HomAttackMotionCancel1 or 0
	AttackMotionCancel2 = set_table.HomAttackMotionCancel2 or 0
	AttackMotionCancel3 = set_table.HomAttackMotionCancel3 or 0
	set_table.HomAttackMotionCancel2SPBorder = set_table.HomAttackMotionCancel2SPBorder or 10
	AttackMotionCancel2SPBorder = GetV(V_MAXSP, MyID) * set_table.HomAttackMotionCancel2SPBorder * 0.01

	if AttackMotionCancel3 == 1 then
		MotionCancel2 = MotionCancel3
	end

	--     IDLE_ST
	if set_table.HomRoundCtrl == 1 then
		RoundCtrl = true
	else
		RoundCtrl = false
	end

	RoundType = set_table.HomRoundType or 9
	RoundRadius = set_table.HomRoundRadius or 1
	RoundMirror = set_table.HomRoundMirror or 0
	RoundHomHP = set_table.HomRoundHP or 90
	RoundStart = set_table.HomRoundStart or 4000
	RoundNext = set_table.HomRoundNext or 1300

	CalcRoundArray()

	
	if (set_table.MaxIdleTimeCtrl == 1 and set_table.MaxIdleTimeTarg == 1) then
		MaxIdleTimeCtrl = true
		set_table.MaxIdleTimeout = set_table.MaxIdleTimeout or 5
		MaxIdleTimeout = set_table.MaxIdleTimeout * 60000
	else
		MaxIdleTimeCtrl = false
		MaxIdleTimeout = 0
	end

	set_table.HomActiveModeMinHP = set_table.HomActiveModeMinHP or 90
	ActiveModeMinHP = GetV(V_MAXHP,MyID) * set_table.HomActiveModeMinHP * 0.01

	local type = GetV(V_HOMUNTYPE,MyID)

	TraceAI ("")
	TraceAI ("Starting AI. Homunculus type is "..type)

	if (type == LIF or type == LIF_H or  type == LIF2 or type == LIF_H2 ) then
	--  
		SetAttackSkill = function() end

		if set_table.L_BoostSkill == 2 then
			BoostSkill	= SKILL_MENTAL_CHANGE
			BoostSkillLevel = set_table.L_MentalChangeLevel or 3

			if set_table.L_MentalChangeType == 1 then
				BoostSkillTiming = 0
			elseif set_table.L_MentalChangeType == 2 then
				BoostSkillTiming = set_table.L_MentalChangeEnemy or 1
			else
				BoostSkillTiming = -1
				BoostSkillCheck = function() end
			end
			set_table.L_MentalChangeStopSP  = set_table.L_MentalChangeStopSP or 1
			BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.L_MentalChangeStopSP * 0.01
		else
			BoostSkill	= SKILL_EMERGENCY_AVOID
			BoostSkillLevel = set_table.L_EmergencyAvoidLevel or 5

			if set_table.L_EmergencyAvoidType == 1 then
				BoostSkillTiming = 0
			elseif set_table.L_EmergencyAvoidType == 2 then
				BoostSkillTiming = set_table.L_EmergencyAvoidEnemy or 1
			else
				BoostSkillTiming = -1
				BoostSkillCheck = function() end
			end
			set_table.L_EmergencyAvoidStopSP = set_table.L_EmergencyAvoidStopSP or 40
			BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.L_EmergencyAvoidStopSP * 0.01
		end

		HealSkill = SKILL_TOUCH_OF_HEAL
		HealSkillTiming = 0
		HealSkillLevelOwner = set_table.L_HealSkillLevel or 5
		HealSkillOwnerHPPerc = set_table.L_HealSkillStopHP or 10
		set_table.L_HealSkillStopSP = set_table.L_HealSkillStopSP or 10
		HealSkillStopSP = GetV(V_MAXSP,MyID) * set_table.L_HealSkillStopSP * 0.01
		HealSkillMaxAttempts = set_table.L_HealSkillMaxAttempts or 3
		set_table.L_HealSkillTimeout = set_table.L_HealSkillTimeout or 60
		HealSkillTimeout = set_table.L_HealSkillTimeout * 1000

		if (HealSkillOwnerHPPerc <= 0) then
			HealSkillCheck = nil
		end

		if (Cmd_MoveToSide[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[0] = 0
		end
		if (Cmd_MoveToSide[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[1] = 0
		end
		if (Cmd_AltRight[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[0] = 0
		end
		if (Cmd_AltRight[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[1] = 0
		end

		UseLambLikeABullet = 0 					-- _c%e'_''+<@"\'-r_-p


	elseif (type == AMISTR or type == AMISTR_H or type == AMISTR2 or type == AMISTR_H2) then
	--  
		SetAttackSkill = function() end

		if set_table.A_BoostSkill == 2 then
			BoostSkill	= SKILL_BLOOD_LUST
			BoostSkillLevel = set_table.A_BloodLustLevel or 3

			if set_table.A_BloodLustType == 1 then
				BoostSkillTiming = 0
			elseif set_table.A_BloodLustType == 2 then
				BoostSkillTiming = set_table.A_BloodLustEnemy or 1
			else
				BoostSkillTiming = -1
				BoostSkillCheck = function() end
			end
			set_table.A_BloodLustStopSP  = set_table.A_BloodLustStopSP or 70
			BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.A_BloodLustStopSP * 0.01
		else
			BoostSkill	= SKILL_DEFFENCE
			BoostSkillLevel = set_table.A_DefenceLevel or 5

			if set_table.A_DefenceType == 1 then
				BoostSkillTiming = 0
			elseif set_table.A_DefenceType == 2 then
				BoostSkillTiming = set_table.A_DefenceEnemy or 5
			else
				BoostSkillTiming = -1
				BoostSkillCheck = function() end
			end
			set_table.A_DefenceStopSP = set_table.A_DefenceStopSP or 40
			BoostSkillStopSP = GetV(V_MAXSP,MyID) * set_table.A_DefenceStopSP  * 0.01
		end

		HealSkillCheck = nil

		if (Cmd_MoveToSide[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[0] = 0
		end
		if (Cmd_MoveToSide[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_MoveToSide[1] = 0
		end
		if (Cmd_AltRight[0] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[0] = 0
		end
		if (Cmd_AltRight[1] >= 100) then			-- BindAction<@"\''_U_'_X_L_<_"'"-''___
			Cmd_AltRight[1] = 0
		end

		UseLambLikeABullet = set_table.UseLambLikeABullet or 1


	elseif (type == FILIR or type == FILIR_H or type == FILIR2 or type == FILIR_H2 ) then
	--  

		AttackSkill	= SKILL_MOONLIGHT
		AttackSkillMaxLevel = 5
--[[
		AttackSkillLevel = set_table.F_MoonLightLevel or 5
		if set_table.F_MoonLightType == 1 then
			AttackSkillTiming = 0
		elseif set_table.F_MoonLightType == 2 then
			AttackSkillTiming = set_table.F_MoonLightProbability or 5
		else
			AttackSkillTiming = -1
		end
--]]
		set_table.F_MoonLightStopSP  = set_table.F_MoonLightStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.F_MoonLightStopSP  * 0.01

		BoostSkill	= SKILL_FLEET_MOVE
		BoostSkillLevel = set_table.F_FleetMoveLevel or 2

		if set_table.F_FleetMoveType   == 1 then
			BoostSkillTiming = 0
		elseif set_table.F_FleetMoveType  == 2 then
			BoostSkillTiming = set_table.F_FleetMoveEnemy or 1
		else
			BoostSkillTiming = -1
			BoostSkillCheck = function() end
		end

		set_table.F_FleetMoveStopSP  = set_table.F_FleetMoveStopSP  or 40
		BoostSkillStopSP		= GetV(V_MAXSP,MyID) * set_table.F_FleetMoveStopSP  * 0.01

		HealSkillCheck = nil
		UseLambLikeABullet = 0 					-- _c%e'_''+<@"\'-r_-p

	elseif (type == VANILMIRTH or type == VANILMIRTH_H or type == VANILMIRTH2 or type == VANILMIRTH_H2) then
	--  
		AttackSkill	= SKILL_CAPRICE
		AttackSkillMaxLevel = 5
--[[
		AttackSkillLevel = set_table.V_CapriceLevel or 5

		if set_table.V_CapriceType == 1 then
			AttackSkillTiming = 0
		elseif set_table.V_CapriceType == 2 then
			AttackSkillTiming = set_table.V_CapriceProbability or 5
		else
			AttackSkillTiming		= -1
		end
--]]
		set_table.V_CapriceStopSP = set_table.V_CapriceStopSP or 5
		AttackSkillStopSP = GetV(V_MAXSP,MyID) * set_table.V_CapriceStopSP * 0.01

		BoostSkillCheck = function() end

		HealSkill = SKILL_CHAOTIC_BENEDICTION
		HealSkillTiming = set_table.V_ChaoticBenedictionType or 1
		HealSkillLevelOwner = set_table.V_HealSkillLevelOwner or 3
		HealSkillLevelHomun = set_table.V_HealSkillLevelHomun or 4
		HealSkillOwnerHPPerc = set_table.V_HealSkillOwnerHPPerc or 90
		HealSkillHomunHPPerc = set_table.V_HealSkillHomunHPPerc or 90
		set_table.V_HealSkillStopSP = set_table.V_HealSkillStopSP or 40
		HealSkillStopSP = GetV(V_MAXSP,MyID) * set_table.V_HealSkillStopSP * 0.01
                HealSkillTimeout = 0

		if (HealSkillOwnerHPPerc <= 0 and HealSkillHomunHPPerc <= 0) then
			HealSkillCheck = nil
		end

		UseLambLikeABullet = 0 		-- _c%e'_''+<@"\'-r_-p
	end

	--  
	AlchSkillUsage = set_table.AlchSkillUsage or 1

	if (AlchSkillUsage > 0) then
		if set_table.AlchHealSkill == 1 then
			AlchHealSkill	= SKILL_AID_POT
			AlchHealSkillLevel = set_table.AlchHealSkillLevel or 1
			AlchHealSkillStopSP = 1

		elseif set_table.AlchHealSkill == 2 then
			AlchHealSkill	= SKILL_HEAL
			AlchHealSkillLevel = set_table.AlchHealSkillLevel or 1
			AlchHealSkillStopSP = 10 + (3*AlchHealSkillLevel)
		end

		AlchHealHomunHPPerc = set_table.AlchHealHomunHPPerc or 30
		AlchHealOwnerHPPerc = set_table.AlchHealOwnerHPPerc or 0
	
		AlchHealMaxAttempts = set_table.AlchHealMaxAttempts or 3
		set_table.AlchHealTimeout = set_table.AlchHealTimeout or 60
		AlchHealTimeout = set_table.AlchHealTimeout * 1000
	else
		AlchHealCheck = function() end
	end

	if set_table.MobIDInfo == 1 then
		OnMainMobID = CollectMobID
		OnIdleMobID = SaveMobID
	end
end


--    tact    id
function GetTact(id, tact)
	local type = GetV(V_HOMUNTYPE,id)

	if (mtact[type] ~= nil and mtact[type][tact] ~= nil) then
		return mtact[type][tact]
	else
		return mtact[0][tact]
	end
end


function HealSkillCheck() 
-------------------------------------------------
--         
-------------------------------------------------
	local nowtime = GetTick()
	local OwnerHP = GetV(V_HP,OwnerID)
	local HomunHP = GetV(V_HP,MyID)
	local HomunSP = GetV(V_SP,MyID)

	if (HealSkillLevelAttempted > 0) then
		if (HealSkill == SKILL_TOUCH_OF_HEAL) then
			TraceAI ("HealSkill: OwnerHP="..OwnerHP..", AttemptedHP="..HealSkillOwnerHPAttempted)
			-- Check if it was successful
			if OwnerHP > HealSkillOwnerHPAttempted then
				TraceAI ("HealSkill: Attempt was apparently successful")
				HealSkillLevelAttempted = 0
				HillSkillFails = 0

			elseif HealSkillTimeAttempted + STUCK_TIMEOUT < nowtime then
				HealSkillFails = HealSkillFails + 1
				HealSkillLevelAttempted = 0

				TraceAI ("HealSkill was failed "..HealSkillFails.." times. nowtime="..nowtime)

				if HealSkillFails >= HealSkillMaxAttempts then
					HealSkillFails = 0
					HealSkillDelay = nowtime + HealSkillTimeout
					TraceAI ("HealSkill was delayed for "..(HealSkillTimeout/1000).." sec")
				end
			else
				return
			end
		end

		if (HealSkill == SKILL_CHAOTIC_BENEDICTION) then
			TraceAI ("HealSkill: HomunSP="..HomunSP..", AttemptedSP="..HealSkillHomunSPAttempted)
			-- Check if it is done
			if HomunSP < HealSkillHomunSPAttempted then
				TraceAI ("HealSkill: Attempt is finished")
				HealSkillLevelAttempted = 0

			elseif HealSkillTimeAttempted + STUCK_TIMEOUT < nowtime then
				TraceAI ("HealSkill is over due timeout "..HealSkillTimeAttempted.."+"..STUCK_TIMEOUT.."<"..nowtime)
				HealSkillLevelAttempted = 0

			else
				return
			end
		end
	end

	if (nowtime < HealSkillDelay) then
		return
	end

    	local OwnerHPPerc = (OwnerHP / GetV(V_MAXHP,OwnerID)) * 100
	local HomunHPPerc = (HomunHP / GetV(V_MAXHP,MyID)) * 100

	if (OwnerHPPerc < HealSkillOwnerHPPerc or HomunHPPerc < HealSkillHomunHPPerc) then
		if ((HealSkillTiming == 1 and MyState == IDLE_ST) or HealSkillTiming == 0) then
			if (OwnerHPPerc / HealSkillOwnerHPPerc) < (HomunHPPerc / HealSkillHomunHPPerc) then
				HealSkillLevelAttempted = UseHealSkill (HealSkillLevelOwner, nowtime)
			else
				HealSkillLevelAttempted = UseHealSkill (HealSkillLevelHomun, nowtime)
			end

			if (HealSkillLevelAttempted > 0) then
				HealSkillTimeAttempted = nowtime
				HealSkillOwnerHPAttempted = OwnerHP
				HealSkillHomunHPAttempted = HomunHP
				HealSkillHomunSPAttempted = HomunSP
			end
		end
	end
end 


function UseHealSkill (level, timeused) 
-------------------------------------------------
--    , 
--   ,   SP
-------------------------------------------------
	if (HealSkill == SKILL_CHAOTIC_BENEDICTION and timeused < SkillDelay) then
		TraceAI ("Heal skill was not used due SkillDelay is not ower")
		return 0
	end

	if (MOTION_STAND ~= GetV(V_MOTION,MyID)) then
		return 0
	end
	if (GetV (V_SP, MyID) < HealSkillStopSP) then
		return 0
	end
	if (GetV (V_SP, MyID) < SKILLDATA[HealSkill][level][SKILL_SP]) then
		return 0
	end

	SkillObject (MyID, level, HealSkill, MyID)
	SkillDelay = math.max (SkillDelay, timeused + SKILLDATA[HealSkill][level][SKILL_DELAY])

	TraceAI ("HealSkill was used at "..timeused.." delay="..((SkillDelay-timeused)/1000).." sec")
--	ShowStatus(string.format("%s :%%%%Count%%%%b",SKILLDATA[HealSkill][level][SKILL_NAME]),SKILLDATA[HealSkill][level][SKILL_DELAY])

	return level
end

 
AlchSkillUsage			= 0	--   
AlchHealSkill			= 0
AlchHealSkillLevel		= 0
AlchHealSkillStopSP		= 0

AlchHealMaxAttempts		= 0	--   
AlchHealTimeout			= 0 	--    
AlchHealSkillDelay		= 0

AlchHealHomunHPPerc		= 0
AlchHealOwnerHPPerc		= 0

AlchHealSkillFails 		= 0	--   
AlchHealLevelAttempted 		= 0	--   ,   
AlchHealTimeAttempted		= 0	--    

AlchHealTarget			= 0	--       
AlchHealTargetPrevHP		= 0	--  HP   ,     

--       ,  ,
--    
function AlchHealCheck ()
	local OwnerHP = GetV(V_HP,OwnerID)
	local HomunHP = GetV(V_HP,MyID)

	local OwnerMotion = GetV(V_MOTION, OwnerID)
	local nowtime = GetTick()

	--     
	if AlchHealLevelAttempted > 0 then
		local HPDelta = 0
		if (AlchHealTarget == OwnerID) then
			HPDelta = OwnerHP - AlchHealTargetPrevHP
		elseif (AlchHealTarget == MyID) then
			HPDelta = HomunHP - AlchHealTargetPrevHP
		end
			
		if (HPDelta > 0) then --or (OwnerMotion == MOTION_PP) then
			TraceAI ("AlchHealCheck: Attempt was apparently successful HPDelta="..HPDelta)
			AlchHealLevelAttempted = 0
			AlchHealSkillFails = 0

		elseif AlchHealTimeAttempted + STUCK_TIMEOUT < nowtime then
			AlchHealSkillFails = AlchHealSkillFails + 1
			AlchHealLevelAttempted = 0

			TraceAI ("AlchHealCheck: Attempt appears to have been unsuccessful "..AlchHealSkillFails.." times")

			if AlchHealSkillFails >= AlchHealMaxAttempts then
				AlchHealSkillDelay = nowtime + AlchHealTimeout
				AlchHealSkillFails = 0
				TraceAI ("AlchHealSkill was delayed for "..(AlchHealTimeout/1000).." sec")
			end
		else
			-- Target's HP delta wasn't positive, so check if
			-- it was better than the last few
			return
		end
	end

	if nowtime < AlchHealSkillDelay then
		return
	end

	if (OwnerMotion == MOTION_SIT
	or OwnerMotion == MOTION_CASTING or OwnerMotion == MOTION_SKILL
	or GetV(V_SP,OwnerID) < AlchHealSkillStopSP) then
		return
	end

    	local OwnerHPPerc = (OwnerHP / GetV(V_MAXHP,OwnerID)) * 100
	local HomunHPPerc = (HomunHP / GetV(V_MAXHP,MyID)) * 100

	-- Check if we need to use HealSkill
	if (OwnerHPPerc <= AlchHealOwnerHPPerc)	or (HomunHPPerc <= AlchHealHomunHPPerc) then
		if (OwnerHPPerc / AlchHealOwnerHPPerc) < (HomunHPPerc / AlchHealHomunHPPerc) then
			AlchHealTarget = OwnerID
			AlchHealTargetPrevHP = OwnerHP
		else
			if (GetDistance (MyX,MyY,OwnerX,OwnerY) > 10) then
				-- Homunculus is far avay, try to move closer
				return
			else
				AlchHealTarget = MyID
				AlchHealTargetPrevHP = HomunHP
			end
		end

		--    
		if (AlchSkillUsage > 1) then 
			local actors = GetActors()
			actors = SelectActors(SELECT_PLAYERS, actors)
			actors = SelectActors(SELECT_NOT_IN, actors, {OwnerID,MasterID})

			if (AlchSkillUsage > 2) then
				--  -
				local isFriend
				for i,actorID in ipairs(actors) do
					isFriend = false

					for friendID,v in pairs(FriendList) do
						isFriend = isFriend or (actorID == friendID)
					end

					if (not isFriend) then
						break
					end
				end

				if (isFriend) then
					actors = {}
				end
			end

			--    
			if (List.getn(actors) > 0) then
				TraceAI("AlchHealCheck: Skill usage blocked due "..List.getn(actors).." players watching")
				return
			end
		end

		SkillObject (MyID, AlchHealSkillLevel, AlchHealSkill, AlchHealTarget)
		TraceAI ("AlchHealSkill was used nowtime="..nowtime.." target is "..AlchHealTarget)

		AlchHealLevelAttempted = AlchHealSkillLevel
		AlchHealTimeAttempted = nowtime
	end
end


function AutoShutdownCheck() 
	local OwnerMotion = GetV(V_MOTION, OwnerID)

	if OwnerMotion == MOTION_MOVE 
	or OwnerMotion == MOTION_PICKUP then
		AutoShutdownTime = GetTick() + AutoShutdownTimeout
	end
end


function CollectMobID()
	Actors = GetActors()
	for i,v in ipairs(Actors) do
		if (v > 0 and IsMonster(v) == 1 and MobID[v] == nil) then
			MobID[v] = GetV(V_HOMUNTYPE,v)
			NewMobID_Flag = 1
		end
	end
end


function SaveMobID()
	if NewMobID_Flag == 1 then
		local fp = io.open(AI_DIR.."Mob_ID.lua", "w")
		if(fp == nil) then return end

		fp:write("MobID={}\n")
		-- _e_[_u_<'''''_L_[_A'l_y_A''''_J''_B
		for i,v in pairs(MobID) do
			fp:write(string.format("MobID[%d]=%d\n", i,v))
		end
		fp:close()

		NewMobID_Flag = 0
	end
end
